#!/usr/bin/perl

###################################################
#### 	  developed by: Nason Tackett          ####
####             nason@nason.com               ####
###################################################

sub WARN_handler {              ## Redefine PERL's warn & die handelers to print any errors to the screen
        my($signal) = @_;
        print "<font size=4 color=red>ERROR: $signal</font><br>\n";
}
 
$SIG{__DIE__} = 'WARN_handler';
$SIG{__WARN__} = 'WARN_handler';


read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/~!/ ~!/g;
    $value =~ s/"/\&quot\;/g;
    $value =~ s/'/\'/g;   
    $FORM{$name} = $value;
}


## Make and array out of the query string
@strings = split(/&/, $ENV{'QUERY_STRING'});
foreach $string (@strings) {
        $string =~ s/%20/ /i;
        $string =~ s/\+/ /ig;
        $string =~ s/\%7C/\|/ig;
        $string =~ s/\%24/\$/ig;
        $string =~ s/\%0A//ig;
        $string =~ s/\%2F/\//ig;
        $string =~ s/\%26/\&/ig;
        $string =~ s/\%27/'/ig;
        $string =~ s/\%28/(/ig;
        $string =~ s/\%29/)/ig;
        ($name,$value) = split(/=/,$string);
        $QUERY{$name} = $value;
}

chdir("../edit");
$schedulen = `./schedulen`;
$schedulen =~ s/\n//ig;
if ($schedulen ne "0" && $schedulen ne "-1") {
        $message = "$schedulen\n";
        &panic;
        exit;
}
chdir("../client");

if ($ENV{'REMOTE_USER'} ne "") {
        $username = $ENV{'REMOTE_USER'};
} elsif ($FORM{'username'} ne "") {
        $username = $FORM{'username'};
} else {
        $message = "Unable to log you in... This could be caused by the directory password protection not functioning properly.\n";
        &panic;
        $dbh->disconnect();
        exit;
}

use DBI();
require "../db.cfg";       ## Database Connection
require "../edit/gig.inc";
require "../edit/employee.inc";
require "../edit/email.inc";
require "../edit/invoice.inc";
require "../edit/gear.inc";

@DAYS = ("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday");
@month = ("", "Jan", "Feb", "March", "April", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec");

$DBI::result = $dbh->prepare("select * from `color setup`");
$DBI::result->execute();
while(@row = $DBI::result->fetchrow_array) {
        $COLORSETUP{$row[1]}=$row[2];
}        

$DBI::result = $dbh->prepare("select * from `setup`");
$DBI::result->execute();
while(@row = $DBI::result->fetchrow_array) {
	$SETUP{$row[0]} = $row[1];
}

$DBI::result = $dbh->prepare("select * from `gig types`");
$DBI::result->execute();
while(@row = $DBI::result->fetchrow_array) {
        $EVENT[$row[0]]=$row[1];
        $COLORS[$row[0]]=$row[2];
} 

$DBI::result = $dbh->prepare("select * from `labor types`");
$DBI::result->execute();
while(@row = $DBI::result->fetchrow_array) {
        $key = $row[0];
        $LABOR{$key}=$row[1];
        $LABOR_ABB{$key}=$row[2];
}


$DBI::result = $dbh->prepare("select * from `employees`");
$DBI::result->execute();  
while(@row = $DBI::result->fetchrow_array) {
        $EMPNAME{$row[0]} = $row[1];
        $EMPLEVEL0{$row[0]} = $row[9];
        $EMPLEVEL1{$row[0]} = $row[10];
        $EMPLEVEL2{$row[0]} = $row[11];
        $EMPLEVEL3{$row[0]} = $row[12];
        $EMPLEVEL4{$row[0]} = $row[13];
}

print "Content-type:text/html\n\n";
print "<body bgcolor=\"#$COLORSETUP{'background'}\" text=\"#$COLORSETUP{'default font'}\">\n";
print "<center><img src=\"$SETUP{'Company Logo'}\"></center>\n";
print "<center><font size=5>$SETUP{'Company Name'} Event Management</font></center><br>\n";
print "<center><font size=3>$SETUP{'Shipping Address'}<br>$SETUP{'Shipping City'}, $SETUP{'Shipping State'}  $SETUP{'Shipping Zip'}<br>$SETUP{'Phone Number'}</font></center><br>\n";
if ($SETUP{'Link At Top'} && $SETUP{'Link At Top Name'}) {
        print "<center><font size=4><a href=\"$SETUP{'Link At Top'}\">$SETUP{'Link At Top Name'}</a></font></center>\n";
}

chdir("../edit");
if ($schedulen eq "-1") {
        $edate = `./gooduntil`;
        $efdate = `date -d '1970-01-01 $edate sec' +"%A, %B %d, %Y"`;
        print "<center><font color=\"#$COLORSETUP{'error font'}\" size=5>30 day trial version</font></center>\n";
        print "<center><font color=\"#$COLORSETUP{'error font'}\" size=3>Good Until: $efdate</font></center>\n";
}
chdir("../client");

print "<FORM METHOD=\"POST\" name=\"toolbar\" ACTION=\"client.cgi\">\n";
print "<input type=\"hidden\" name=\"username\" value=\"$username\">\n";
print "<center><table bgcolor=\"#$COLORSETUP{'table background'}\" bordercolor=\"#$COLORSETUP{'table bordercolor'}\" border=1><tr><td><input type=\"submit\" name=\"show\" value=\"Show Schedule\"><input type=\"submit\" name=\"directory\" value=\"Phone & Email Directory\"><input type=\"submit\" name=\"settings\"value=\"Account Settings\"></td></tr></table></center>\n";
print "</form>\n";

$FORM{'notes'} =~ s/\\n/\<br\>/ig;

$DBI::result = $dbh->prepare("select * from `clients` WHERE `username`='$username'");
$DBI::result->execute();
while(@row = $DBI::result->fetchrow_array) {
        $clientnum=$row[0];
	$clientname=$row[1];
        $phone=$row[4];
        $email=$row[3];
        $contact=$row[5];
        $CalView = $row[7];
	$lastlogin = $row[8];
}

if ($ENV{'HTTP_REFERER'} !~ /client.cgi/) {
        $datestamp = `date`;
        $datestamp =~ s/\n//ig;
        $dbh->do("UPDATE `clients` SET `last login` = \"$datestamp\" WHERE `num` = \"$clientnum\"");
        print "<center><b>Last Login: $lastlogin</b></center><br>\n";
}

foreach $key (%FORM) {
	if ($FORM{$key} eq "Delete") {
		$delete = $key;
		&clientdeletegig;
		&credit;
		$dbh->disconnect();
		exit;
        } elsif ($FORM{$key} eq "Confirm Delete") {
		if ($FORM{'whydelete'} ne "") {
			$delete = $key;
			&confirmclientdeletegig;
		} else {
			$delete = $key;
			$errormsg = "<center><font color=\"#$COLORSETUP{'error font'}\" size=4>Error! Please give us a reason why you are removing this event!</font></center>";  
                	&clientdeletegig;
			&credit;
			$dbh->disconnect();
			exit;
		}
	} elsif ($FORM{$key} eq "Edit" || $FORM{$key} eq "Ok") {
		if ($FORM{'uploadsucess'} eq 1) {
			$date = $key;
		        $changed = "<font color=red><b><u>Items Modified</u></b><br><li>File Attachment Uploaded<br>\n";
        		$changedtrue=1;
		        &updatenotify;
		}
		$edit = $key;
		$hidefromclient=1;
		&getemployeelabortypes;
		&getlaborneeded;
		&getcurrentlabor;
		&edit;
		&credit;
		$dbh->disconnect();
		exit;
        } elsif ($FORM{$key} eq "Change Client") {
                $edit = $key;
                &editclient;
                &client;
		&credit;
                $dbh->disconnect();
                exit;
        } elsif ($FORM{$key} eq "View Equipment List") {
		$hide=1;
                $hidefromclient=1;
                $date = $key;
                &editgear;
                &credit;
                $dbh->disconnect();
                exit;
        } elsif ($FORM{$key} eq "Add Notes") {
                $edit = $key;
		&appendnotes;
                $hidefromclient=1;
                &getemployeelabortypes;
                &getlaborneeded;
                &getcurrentlabor;
                &edit;
                &credit;
                $dbh->disconnect();
                exit;
        } elsif ($FORM{$key} eq "Submit Changes") {
                &changes;
       		&settings; 
        	&credit; 
        	$dbh->disconnect(); 
        	exit; 
        } elsif ($FORM{$key} eq "Change Password") {
                &changepasswd;
        	&settings; 
        	&credit; 
        	$dbh->disconnect(); 
        	exit; 
	} 
}

if ($FORM{'new'}) {
	&new;
} elsif ($FORM{'addlink'}) {
        $active = $FORM{'active'};
	$edit = $FORM{'date'};
	$date = $edit;
	&addlink;
        $changed = "<font color=red><b><u>Items Modified</u></b><br><li>File Attachment Uploaded<br>\n";
        $changedtrue=1;
        &updatenotify;	
	$hidefromclient=1;
	&getemployeelabortypes;
	&getlaborneeded;
	&getcurrentlabor;
        &edit;
	&credit;
        $dbh->disconnect();
        exit;   
} elsif ($FORM{'settings'}) {
        &settings;
        &credit;
        $dbh->disconnect();
        exit;
} elsif ($FORM{'directory'}) {
        &directory;
        &credit;
        $dbh->disconnect();
        exit;
}

foreach $key (%QUERY) { 
        if ($QUERY{$key} eq "View") {
                $edit = $key;
                $date = $key;
                &getemployeelabortypes;
                &getlaborneeded;
                &getcurrentlabor;
		$hidefromclient=1;
                &edit;
                &credit;
                $dbh->disconnect();
                exit;   
        }
}


if ($FORM{'prevmonth'}) {
	if ($FORM{'browsemonth'} eq "1") {
		$FORM{'browseyear'}--;
		$FORM{'browsemonth'}=12;
	} else {
		$FORM{'browsemonth'}--;
	}
}

if ($FORM{'nextmonth'}) {
        if ($FORM{'browsemonth'} eq "12") {
                $FORM{'browseyear'}++;
                $FORM{'browsemonth'}=1;
        } else {
                $FORM{'browsemonth'}++;
        }
}

if ($FORM{'calendarview'}) {
        $dbh->do("UPDATE `clients` SET `CalView` = \"1\" WHERE `num` = \"$clientnum\"");
        $CalView=1; 
}
        
if ($FORM{'listview'}) {
        $dbh->do("UPDATE `clients` SET `CalView` = \"0\" WHERE `num` = \"$clientnum\"");
        $CalView=0;
}

&print_my_delinquent;

if ($CalView  eq "1") {
	if ($FORM{'browseyear'} ne "") {
		$browseyear = $FORM{'browseyear'};
	} else {
		$browseyear = `date +%Y`;
		$browseyear =~ s/\n//ig;
	}
	if ($FORM{'browsemonth'} ne "") {
		$browsemonth = $FORM{'browsemonth'};
	} else {
		$browsemonth = `date +%m`;
		$browsemonth =~ s/\n//ig;
	}
	$title = "$month[$browsemonth], $browseyear";
        $begmon = ($browseyear * 10000) + ($browsemonth * 100);
        $endmon = $begmon + 100;
        $DBI::result = $dbh->prepare("select * from `gigs` WHERE `date` >= \"$begmon\" AND `date` < \"$endmon\" AND `client`='$clientnum' ORDER BY `date` ASC");
        $DBI::result->execute();
} else {
	if ($FORM{'showhist'}) {
		if ($FORM{'hisyear'}) {
			$title = "Showing History for $FORM{'hisyear'}";
			$hisyear = $FORM{'hisyear'} * 10000;
			$ltyear = $hisyear + 10000;
			$DBI::result = $dbh->prepare("select * from `gigs` WHERE `active`='0' AND `date` >= \"$hisyear\" AND `date` < \"$ltyear\" AND `client`='$clientnum' ORDER BY `date` DESC");
			$DBI::result->execute();
		} else {
			$title = "Showing All Past History";
		        $DBI::result = $dbh->prepare("select * from `gigs` WHERE `active`='0' AND `client`='$clientnum' ORDER BY `date` DESC");
		        $DBI::result->execute();
		}
	} else {
		$title = "Current Dates";	
		$DBI::result = $dbh->prepare("select * from `gigs` WHERE `active`='1' AND `client`='$clientnum' ORDER BY `date` ASC");
		$DBI::result->execute();
	}
}

open(HEAD,"popup.html");
@HEAD = <HEAD>;
close HEAD;
foreach $line (@HEAD) {
	print $line;
}

&getemployee;

print <<EOT;
<script language = "Javascript">
/**
 * DHTML date validation script. Courtesy of SmartWebby.com (http://www.smartwebby.com/dhtml/)
 */
// Declaring valid date character, minimum year and maximum year
var dtCh= "/";
var minYear=1900;
var maxYear=2100;

function isInteger(s){
	var i;
    for (i = 0; i < s.length; i++){   
        // Check that current character is number.
        var c = s.charAt(i);
        if (((c < "0") || (c > "9"))) return false;
    }
    // All characters are numbers.
    return true;
}

function stripCharsInBag(s, bag){
	var i;
    var returnString = "";
    // Search through string's characters one by one.
    // If character is not in bag, append to returnString.
    for (i = 0; i < s.length; i++){   
        var c = s.charAt(i);
        if (bag.indexOf(c) == -1) returnString += c;
    }
    return returnString;
}

function daysInFebruary (year){
	// February has 29 days in any year evenly divisible by four,
    // EXCEPT for centurial years which are not also divisible by 400.
    return (((year % 4 == 0) && ( (!(year % 100 == 0)) || (year % 400 == 0))) ? 29 : 28 );
}
function DaysArray(n) {
	for (var i = 1; i <= n; i++) {
		this[i] = 31
		if (i==4 || i==6 || i==9 || i==11) {this[i] = 30}
		if (i==2) {this[i] = 29}
   } 
   return this
}

function isDate(dtStr){
	var daysInMonth = DaysArray(12)
	var pos1=dtStr.indexOf(dtCh)
	var pos2=dtStr.indexOf(dtCh,pos1+1)
	var strMonth=dtStr.substring(0,pos1)
	var strDay=dtStr.substring(pos1+1,pos2)
	var strYear=dtStr.substring(pos2+1)
	strYr=strYear
	if (strDay.charAt(0)=="0" && strDay.length>1) strDay=strDay.substring(1)
	if (strMonth.charAt(0)=="0" && strMonth.length>1) strMonth=strMonth.substring(1)
	for (var i = 1; i <= 3; i++) {
		if (strYr.charAt(0)=="0" && strYr.length>1) strYr=strYr.substring(1)
	}
	month=parseInt(strMonth)
	day=parseInt(strDay)
	year=parseInt(strYr)
        if (pos1==-1 || pos2==-1){
                alert("The date format should be : mm/dd/yyyy")
                document.top.month.focus()
                return false
        }
        if (strMonth.length<1 || month<1 || month>12){
                alert("Please enter a valid month")
                document.top.month.focus()
                return false
        }
        if (strDay.length<1 || day<1 || day>31 || (month==2 && day>daysInFebruary(year)) || day > daysInMonth[month]){
                alert("Please enter a valid day")
                document.top.day.focus()
                return false
        }
        if (strYear.length != 4 || year==0 || year<minYear || year>maxYear){
                alert("Please enter a valid 4 digit year between "+minYear+" and "+maxYear)
                document.top.year.focus()
                return false
        }   
        if (dtStr.indexOf(dtCh,pos2+1)!=-1 || isInteger(stripCharsInBag(dtStr, dtCh))==false){
                alert("Please enter a valid date")
                document.top.month.focus()
                return false
        }
return true
}  
        
function ValidateForm(){
        var dt=document.top.month.value + '/' + document.top.day.value + '/' + document.top.year.value
        if (isDate(dt)==false){
//              document.top.month.focus()
                return false
        }
    return true
 }

</script>

<FORM METHOD="POST" name="top" ACTION="client.cgi">   
<input type="hidden" name="username" value="$username">

        <center><table bgcolor="#$COLORSETUP{'table background'}" bordercolor="#$COLORSETUP{'table bordercolor'}" border=1>
        <tr><td><b>Add an event for approval</b></td></tr>
        <tr><td>
        Date: <input type="text" name="month" length="2" size="2">/<input type="text" name="day" length="2" size="2">/<input type="text" name="year" length="4" size="4"><br>
        Setup/Arrival Time: <input type="text" name="stime" length="20" size="10">  Event Time: <input type="text" name="time" length="20" size="10"><br>
        Description: <input type="text" name="location" size="40"><br>
        <input type="hidden" name="client" value="$clientnum">
        <input type="hidden" name="clientsemail" value="$email">
        <input type="hidden" name="clientsphone" value="$phone">
	<input type="hidden" name="pending" value="1">
	<input type="hidden" name="cliententry" value="1">
        </td></tr><tr><td>
        <center><table width=100% border=0><tr><td>
        Notes:<br>
        <textarea rows="8" name="notes" cols="25"></textarea><br>
	<input type="hidden" name="sendout" value="0">
        <input type="submit" name="new" value="Submit" onClick=\"return ValidateForm()\">
        </td></tr></table></center></td></tr></table></center>
        <br><br>
EOT

print "<center><table border=1><caption>Event Type Color Codes:</caption><tr>\n";
$num=0;
foreach $gig_type (@EVENT) {
        if ($num > 0 && $EVENT[$num] ne "") {
                print "<td><font color=\"#$COLORS[$num]\">$EVENT[$num]</td>\n";
        }
        $num++;
}   
print "</tr></table></center><br>\n";

print <<EOT;
<center><u><font size="5">$title</font></u></center>
<center><font size="2" color="#$COLORSETUP{'labor full highlight'}">(Blue highlight indicates all labor slots filled)</font></center>
<br>
EOT

$TOTALPAID=0.00;

if ($CalView eq "1") {
        print <<EOT;
        <input type="hidden" name="username" value="$username">
        <input type="hidden" name="browsemonth" value="$browsemonth">
        <input type="hidden" name="browseyear" value="$browseyear">
        <input type="hidden" name="iscalendarview" value="true">
EOT
        print "<center><input type=\"submit\" name=\"prevmonth\" value=\"Previous Month\">  <input type=\"submit\" name=\"listview\" value=\"Show asList View\"><input type=\"submit\" name=\"nextmonth\" value=\"Next Month\"></center>\n";

        while(@row = $DBI::result->fetchrow_array) {

                $date=$row[0];
                &getlaborneeded;
                &getcurrentlabor;

                $row[2] =~ s/\"/"/g;
                $row[2] =~ s/\'/`/g;
                $row[4] =~ s/\"/"/g;
                $row[4] =~ s/\'/`/g;
                $row[6] =~ s/\"/"/g;
                $row[6] =~ s/\'/`/g;

                $color = "#$COLORS[$row[1]]";

                $peopleneeded = 0;
                %emptylabor=();
                foreach $key (sort keys %LABOR) {                       ## Calculate the empty labor slots needed
                        $emptylabor{$key} = $LABORNEEDED{$key} - $CURRENTLABOR{$key};
                        $peopleneeded = $peopleneeded + $emptylabor{$key};
                }

                ($thisdatesplit,$junk) = split(/\./,$row[0]);

                if ($peopleneeded eq "0") {
                        $highlight = "#$COLORSETUP{'labor full highlight'}";
                } else {
                        $highlight = "#$COLORSETUP{'calendar background'}";
                }

                $pendingwarn = "";
                if ($row[22] eq "1") {  ## If gig is marked as pending/tentative
                        $highlight = "#FF0000";
                        $pendingwarn = "<font color=red size=4>This event is tentative!</font><br>";
                }

                $wy = substr($row[0],2,2);
                $wm = substr($row[0],4,2);
                $wd = substr($row[0],6,2);

                $datestr = "$wy$wm$wd";
                $wday = `date -d $datestr +%w`;

                $EVENT_BY_DAY{$wd}=$EVENT_BY_DAY{$wd} . "<table><tr>";
                $row[4] =~ s/\n/\\n/ig;
                $row[4] =~ s/\r//ig;
                $construct = "<table width=400 border=1><tr><td colspan=2>$pendingwarn<small><font color=black>$DAYS[$wday], $row[2]  $row[6]</font></small></td></tr><tr><td width=55% valign=top><small><font color=black>$row[4]</font></small></td><td valign=top><font color=black><small><u>Working:</u><br>@workingnames</small></font></td></tr></table>";
                $EVENT_BY_DAY{$wd}=$EVENT_BY_DAY{$wd} . "<td bgcolor=\"$highlight\"><a href=\"client.cgi?$row[0]=View\"ONMOUSEOVER=\"popup('$construct','yellow')\"\; ONMOUSEOUT=\"kill()\">$row[2]</a></td>";
                $EVENT_BY_DAY{$wd}=$EVENT_BY_DAY{$wd} . "</tr></table><br>\n";
		$TOTALPAID=$TOTALPAID+$row[3];
        }

        $browsemonth = sprintf ("%02d",$browsemonth);
        $datestr = $browseyear . $browsemonth . "01";
        $startday = `date -d $datestr +%w`;
        $startday =~ s/\n//ig;
        print "<center><table border=1 width=\"1000\">\n";
        print "<tr><td width=\"143\">Sunday</td><td width=\"143\">Monday</td><td width=\"143\">Tuesday</td><td width=\"143\">Wednesday</td><td width=\"143\">Thursday</td><td width=\"143\">Friday</td><td width=\"143\">Saturday</td></tr>\n";
        $myday=0;
        $printcalendar=1;
        $rows=1;
        $numberofdays = `cal $browsemonth \`date +$browseyear\` | egrep -v '[A-Za-z]' | wc -w`;
        $numberofdays =~ s/\n//ig;
        $currentmonth = `date +%m`;
        $currentmonth =~ s/\n//ig;
        $currentday = `date +%d`;
        $currentday =~ s/\n//ig;
        $currentyear = `date +%Y`;
        $currentyear =~ s/\n//ig;

        while ($myday <= $numberofdays && $rows < 7) {
                if ($myday <= $numberofdays) {
                        $mywday=0;
                        for (0..6) {
                                if ($myday <= $numberofdays) {
                                if ($mywday eq "0") {
                                        print "<tr height=\"150\">\n";
                                }
                                if ($myday eq "0") {
                                        if ($startday eq $mywday) {
                                                $myday=1;
                                                $todaycolor = "white";
                                                if ($currentday eq $myday && $currentmonth eq $browsemonth && $currentyear eq $browseyear) {
                                                        $todaycolor = "#FFFF99";
                                                }
                                                $mydayf = sprintf("%02d",$myday);
                                                print "<td bgcolor=\"$todaycolor\" valign=\"top\">1.<br>$EVENT_BY_DAY{$mydayf}</td>\n";
                                                $myday++;
                                        } else {
                                                print "<td></td>\n";
                                        }
                                } else {
                                        $todaycolor = "white";
                                        if ($currentday eq $myday && $currentmonth eq $browsemonth && $currentyear eq $browseyear) {
                                                $todaycolor = "#FFFF99";
                                        }
                                        $mydayf = sprintf("%02d",$myday);
                                        print "<td bgcolor=\"$todaycolor\" valign=\"top\">$myday.<br>$EVENT_BY_DAY{$mydayf}</td>\n";
                                        $myday++;
                                }
                                if ($mywday eq "6") {
                                        print "</tr>\n";
                                }
                                $mywday++;
                                }
                        }
                        $rows++;
                }
        }
        print "</table>\n";
} else {

print <<EOT;
<center><table borderColor="#$COLORSETUP{'table bordercolor'}" bgColor="#$COLORSETUP{'table background'}" border="1" width="700">
    <tr>
        <td colspan="2" width="690">
           <center><font face="Courier New" size="4">Event Display</font>
        </td>
    </tr>
    <tr>
        <td width="35%">
          <p align="center"><input type="submit" value="Show Current" name="show">
      </td>
        <td width="65%">
           <center>Show History by year: <input size="4" name="hisyear"> (type a 4 digit year)<input type="submit" value="View History" name="showhist"></center>
      </td>
    </tr>
  </table></center><br>
EOT

##&printjavawarn;

print <<EOT;
<input type="hidden" name="username" value="$username">
<center><input type="submit" name="calendarview" value="Show as Calendar View"></center>
<center><table border=1 width="1000">
<tr>
<td>&nbsp;</td>
<td width="250">Labor</td>
<td width="500">Date & Description</td>
<td>Time</td>
<td>Fee</td>
<td>Paid</td>
<td>Roundtrip Miles</td>
<td>Notes</td>
<td width="100">Attachments</td>
<td>&nbsp;</td></tr>

EOT

while(@row = $DBI::result->fetchrow_array) {
        $ref++;
        $date=$row[0];
        &getlaborneeded;
        &getcurrentlabor;

        $row[2] =~ s/\"/"/g;
        $row[2] =~ s/\'/'/g;
        $row[4] =~ s/\"/"/g;
        $row[4] =~ s/\'/'/g;
        $row[4] =~ s/\'/'/g;
        $row[6] =~ s/\"/"/g;
        $row[6] =~ s/\'/'/g;

        $color = "#$COLORS[$row[1]]";

        $peopleneeded = 0;
        %emptylabor=();
        foreach $key (sort keys %LABOR) {                       ## Calculate the empty labor slots needed
                $emptylabor{$key} = $LABORNEEDED{$key} - $CURRENTLABOR{$key};
                $peopleneeded = $peopleneeded + $emptylabor{$key};
        }

        if ($peopleneeded eq "0") {
                $highlight = "#$COLORSETUP{'labor full highlight'}";
        } else {
                $highlight = "#$COLORSETUP{'calendar background'}";
        }

        $pendingwarn = "";
        if ($row[22] eq "1") {  ## If gig is marked as pending/tentative
                $highlight = "#FF0000";
                $pendingwarn = "<font color=white size=4>This event is tentative!</font><br>";
        }

        ($thisdatesplit,$junk) = split(/\./,$row[0]);
        $wy = substr($row[0],2,2);
        $wm = substr($row[0],4,2);
        $wd = substr($row[0],6,2);

        $datestr = "$wy$wm$wd";
        $wday = `date -d $datestr +%w`;

        $files = $row[16];

	print "<tr><td bgcolor=\"$highlight\"><input type=\"submit\" name=\"$row[0]\" value=\"Edit\"></td>\n";
        print "</td><td bgcolor=\"$highlight\"><table border=0>\n";

        $laborneededhtml = "";
	
        foreach $key (reverse sort keys %LABORNEEDED) {
                $num=$LABORNEEDED{$key};
                while ($num >= 1) {
                        $indexnum = (($LABORNEEDED{$key} - $num) +1);
                        print "<tr><td><font color=\"$color\"><small>$LABOR{$key}:</small></font></td><td><fontcolor=\"$color\"><small>$EMPLOYEES{$LABOR_NUM[$key][$indexnum]}</small></font></td></tr>\n";
                        $num--;
                }
        }
        if ($row[21] eq "1") {
                $payment_received = "<font color=\"green\">YES</font>";
        } else {
                $payment_received = "<font color=\"red\">NO</font>";
        }

        print "</table></td><td bgcolor=\"$highlight\">$pendingwarn<font color=\"$color\">$DAYS[$wday], $row[2]</font></td><td bgcolor=\"$highlight\"><font color=\"$color\">$row[6]&nbsp;</font></td><td bgcolor=\"$highlight\"><font color=\"$color\">\$$row[3]</font></td><td bgcolor=\"$highlight\"><font color=\"$color\">$payment_received</font></td>\n";
	print "<td bgcolor=\"$highlight\"><font color=\"$color\">$row[15]</font></td>\n";
        if ($row[4] ne "") {
                $row[4] =~ s/\n/\\n/ig;
                $row[4] =~ s/\r//ig;
                print "<td bgcolor=\"$highlight\"><a href=\"client.cgi\"ONMOUSEOVER=\"popup('<font color=black>$row[4]</font>','yellow')\"\; ONMOUSEOUT=\"kill()\">Notes</a></td>\n";
        } else {
                print "<td bgcolor=\"$highlight\"><font color=\"#808080\">No Notes</font></td>\n";
        }
        print "<td bgcolor=\"$highlight\" width=\"100\"><font size=\"1\"><small>$files</font></small></td>\n";
        print "<td bgcolor=\"$highlight\"><input type=\"submit\" name=\"$row[0]\" value=\"Delete\"></td></tr>\n";
	$TOTALPAID=$TOTALPAID+$row[3];
}
}
print "</table><br><br>\n";
print "<center><b>Total for dates shown above: \$$TOTALPAID</b></center>\n";
&credit;

sub panic {
        print "Content-type:text/html\n\n";
        print "<center><font color=\"#$COLORSETUP{'error font'}\"><h2>ERROR</h2></font></center>\n";
        print "<center><font size=5 color=\"#$COLORSETUP{'error font'}\">$message</font></center>\n";
}

$dbh->disconnect();
exit;

sub print_my_delinquent {

        $DBI::result = $dbh->prepare("select * from `gigs` WHERE `active` = '0' AND `payment_received` = '0' AND `client`=\"$clientnum\"");
        $DBI::result->execute();
                        
        while(@row = $DBI::result->fetchrow_array) {
                if ($delinquent_header ne "1") {
                        print "<center><table bgcolor=\"#$COLORSETUP{'table background'}\" bordercolor=\"#$COLORSETUP{'table bordercolor'}\" border=1><tr><td colspan=\"2\"><font color=\"#$COLORSETUP{'delinquent font'}\">Payment(s) Due</font></td></tr>\n";
                        $delinquent_header = "1";
                }
                $owe = $row[3]-$row[10];
                print "<tr><td><font color=\"#$COLORSETUP{'delinquent font'}\">$row[2]</font></td><td><font color=\"#$COLORSETUP{'delinquent font'}\">Owe: \$$owe</font></td></tr>\n";
                $total_delinquent = $total_delinquent + $owe;
        }
        if ($delinquent_header eq "1") {
                print "<tr><td><font color=\"#$COLORSETUP{'delinquent font'}\">TOTAL</font></td><td><font color=\"#$COLORSETUP{'delinquent font'}\">\$$total_delinquent.00</font></td></tr>\n";
                print "</table><br><br>\n";
        }               
}                                             
1;

sub changepasswd {
                        
        if ($FORM{'newpassword'} eq "") {
                print "<center><h2>You did not enter a new password!</h2></center>\n";
                $skip = "1";
        } elsif ($FORM{'newpassword'} ne $FORM{'newpassword2'}) {
                print "<center><h2>Passwords do not match!</h2></center>\n";
                $skip = "1";
        } elsif ($FORM{'newpassword'} =~ /\s/ || $FORM{'newpassword'} =~ /\"/ || $FORM{'newpassword'} =~ /\'/) {
                print "<center><h2>Password contains invalid characters!</h2></center>\n";
                $skip = "1";
        } 
                
        unless ($skip eq "1") {
        
                srand($$|time);
                @saltchars=(a..z,A..Z,0..9,'.','/');
                $salt=$saltchars[int(rand($#saltchars+1))];
                $salt.=$saltchars[int(rand($#saltchars+1))];
                $passwdcrypt = crypt($FORM{'newpassword'},$salt);
        
                open (HTPASSWD,".htpasswd");
                flock(HTPASSWD, 2);
                @HTPASSWD = <HTPASSWD>;
                close HTPASSWD;
                open (HTPASSWD,">.htpasswd");
                flock(HTPASSWD, 2);
                foreach $line (@HTPASSWD) {   
                        chop($line);
                        ($name,$passwd) = split(':', $line);
                        if ($name eq $username) {
                                print HTPASSWD "$name\:$passwdcrypt\n";
                        } else {
                                print HTPASSWD "$line\n";
                        }
                }
                close HTPASSWD;
        
                print "<center><h2>Password updated!</h2></center>\n";
        }
}

sub changes {
        if ($FORM{'email'} =~ /[\~\`\!\#\$\%\^\&\*\(\)\+\=\{\[\}\]\|\\\:\;\"\'\<\>\/\?]/ || $FORM{'email'} !~ /@/ || $FORM{'email'} !~ /\./) {
                print "<center><h2>Email Address is Invalid!</h2></center>\n";
        } else {
		$dbh->do("UPDATE `clients` SET `contact` = \"$FORM{'contact'}\", `email` = \"$FORM{'email'}\", `phone` = \"$FORM{'phone'}\" WHERE `num` =\"$clientnum\"");
	}

	$DBI::result = $dbh->prepare("select * from `clients` WHERE `username`='$username'");
	$DBI::result->execute();
	while(@row = $DBI::result->fetchrow_array) {
	        $clientnum=$row[0];
	        $phone=$row[4];
	        $email=$row[3];
	        $contact=$row[5];
	        $CalView = $row[7];
	}

}       

sub invoicelink {
                        $s0=substr($edit,0,1);
                        $s1=substr($edit,1,1);
                        $s2=substr($edit,2,1);
                        $s3=substr($edit,3,1);
                        $s4=substr($edit,4,1);
                        $s5=substr($edit,5,1);
                        $s6=substr($edit,6,1);
                        $s7=substr($edit,7,1);
                        $s8=substr($edit,9,1);
                        $s9=substr($edit,10,1);
                        $sa=substr($row[2],5,1);
                        $sb=substr($row[2],2,1);
                        $sc=substr($row[2],1,1);
                        $sd=substr($row[2],3,1);
                        $invoicehash = $s2.$s9.$sa.$s1.$s7.$sb.$s4.$s8.$s0.$sc.$s6.$s3.$sd.$s5;
                        $invoicelink = "http://$SETUP{'Domain Name'}/cgi-bin/invoice.cgi?invoicehash=$invoicehash";
}
1;             

sub credit {
        print "<br><br><center><a href=\"http://nason.com\">Schedule'N Event Management 2.3 &copy;2008 Nason Tackett</a></center>\n";
}       

sub getclients {
        $DBI::result = $dbh->prepare("select * from `clients`");
        $DBI::result->execute();
        while(@row = $DBI::result->fetchrow_array) {
                $CLIENT_NAME{$row[0]}=$row[1];
                $CLIENT_CONTACT{$row[0]}=$row[5];
                $CLIENT_EMAIL{$row[0]}=$row[3];
                $CLIENT_PHONE{$row[0]}=$row[4];
                $CLIENT_NOTES{$row[0]}=$row[6];
        }
}
1;

sub appendnotes {
        $DBI::result = $dbh->prepare("select * from `gigs` WHERE `date` = \"$edit\"");
        $DBI::result->execute();
        my $notes = "";
        while(my @row = $DBI::result->fetchrow_array) {
                $notes = $row[4];
        }
	$FORM{'appendnotes'} =~ s/\n/\<br\>/ig;
        my $datestamp = `date`;
	$datestamp =~ s/\n//ig;        
        my $newnotes = "$notes<br><br>----------------------------<br>$contact @ $datestamp<br>----------------------------<br>$FORM{'appendnotes'}<br>";
                
        my $MYSQL = "UPDATE `gigs` SET `notes`=\"$newnotes\" WHERE `date`=\"$edit\"";
        $dbh->do("$MYSQL");
}
1;

sub clientdeletegig {
print <<EOT;
	<FORM METHOD="POST" name="top" ACTION="client.cgi">
	<input type="hidden" name="username" value="$username">
	$errormsg;   
        <center><table bgcolor="#$COLORSETUP{'table background'}" bordercolor="#$COLORSETUP{'table bordercolor'}" border=1>
        <tr><td><b>Please let us know why you are removing this event from our schedule.</b></td></tr>
        <tr><td>
        <textarea rows="8" name="whydelete" cols="75"></textarea><br>
        <input type="submit" name="show" value="Cancel"><input type="submit" name="$delete" value="Confirm Delete">
        </td></tr></table></center></td></tr></table></center>
        <br><br>
EOT
}


sub confirmclientdeletegig {
        $DBI::result = $dbh->prepare("select * from `gigs` WHERE `date` = \"$delete\"");
        $DBI::result->execute();
	$eventmonth = substr($delete,4,2);
	$eventday = substr($delete,6,2);
	$eventyear = substr($delete,0,4);
	$datestr = "$eventyear$eventmonth$eventday";	
	$eventwday = `date -d $datestr +%w`;
        while(my @row = $DBI::result->fetchrow_array) {
		$sub = "Client Removed An Event on $DAYS[$eventwday],$month[$eventmonth] $eventday, $eventyear";
		$message = "This is a notice that your client, $clientname, has removed the following event:<br>\n<br>\n$row[2]<br>\n<br>\nThe client has removed this event for the following reasons:<br>\n$FORM{'whydelete'}";
        }       
	$to = $SETUP{'Email Address'};
	&sendmail;
	&delete;        ## Call the real delete subroutine
	print "<center><font color=\"#$COLORSETUP{'error font'}\" size=4>Event Removed!</font></center>\n";
}

sub directory {
print <<EOT;
<center>
<table borderColor="#$COLORSETUP{'table bordercolor'}" bgColor="#$COLORSETUP{'table background'}" border="1">
  <tbody>
    <tr> 
      <td height="19" colspan="6"><b>Employee Contact Info</b></td>
    </tr>
            <tr>
              <td>Name</td>  
              <td>Phone</td> 
              <td>Email 1</td>
              <td>Email 2</td>
            </tr>
EOT
        $DBI::result = $dbh->prepare("select * from `employees` WHERE `active` = '1' ORDER BY `employee` ASC");
        $DBI::result->execute();
        while(@row = $DBI::result->fetchrow_array) {
                print "<tr>\n";
                print "<td>$row[1]</td>\n";
                print "<td>$row[14]</td>\n";
                print "<td><a href=\"mailto:$row[4]\">$row[4]</a></td>\n";
                print "<td><a href=\"mailto:$row[5]\">$row[5]</a></td>\n";
                print "</tr>\n";
        }
        $dbh->disconnect();
                
print <<EOT;
  </tbody>
</table> 
</center>
                
EOT

}


sub settings {
&getemployee;
                        
print <<EOT;
<FORM METHOD="POST" name="top" ACTION="client.cgi">
<input type="hidden" name="username" value="$username">

<center><table borderColor="#$COLORSETUP{'table bordercolor'}" bgColor="#$COLORSETUP{'table background'}" border="1" width="700">
    <tr> 
        <td>
           <center><font face="Courier New" size="4">Account Settings</font>
        </td>
    </tr>
      <tr>
        <td>
	Contact: <input size="30" name="contact" value="$contact">
        <br>
        Phone: <input size="15" name="phone" value="$phone">
        <br>
        Email: <input size="30" name="email" value="$email">
        <br>
          <p><input type="submit" value="Submit Changes" name="change">
        <br>
        </td>
      </tr></table>
<br>
<table borderColor="#$COLORSETUP{'table bordercolor'}" bgColor="#$COLORSETUP{'table background'}" border="1" width="700">
    <tr>
        <td>
           <center><font face="Courier New" size="4">Change Password</font>
        </td>
    </tr>
      <tr><td>
        <br>  
<center>
New password: <input type="password" size="30" name="newpassword">&nbsp;Retype password: <input type="password" size="30" name="newpassword2"><br>
<input type="submit" value="Change Password" name="changepasswd">
</center>
    </td></tr>
</table>
<br>
EOT

}

